from sqlalchemy import create_engine, MetaData, Table, insert, null, select,update,delete,text
from sqlalchemy.sql import and_, or_
from sqlalchemy import asc, desc
from core import app
import json
from .. import engine


class ExportFilterCols():
	def __init__(self):
		try:
			self.meta         			 = MetaData()
			self.export_filter_cols      = Table("export_filter_cols", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)

	def get_export_columns(self,society_id):
		with engine.connect() as conn:
			stmt 	= text("select * from export_filter_cols where FIND_IN_SET (:society_id,society_ids)  and is_visible =1 and is_mem =1 order by orderby asc;")
			result 	= conn.execute(stmt.bindparams(society_id=society_id)).all()
			results = [dict(r._mapping) for r in result] if result else None
			conn.close()
			if results:
				return results
			else:
				return None

	def get_select_columns(self,export_columns,society_id):
		with engine.connect() as conn:
			stmt 	= text("select * from export_filter_cols where FIND_IN_SET (:society_id,society_ids)  and is_visible =1 and is_mem =1 and cols_value_name in ("+str(export_columns)+") and orderby is not null order by FIELD(cols_value_name,"+str(export_columns)+");")
			result 	= conn.execute(stmt.bindparams(society_id=society_id)).all()
			results = [dict(r._mapping) for r in result] if result else None
			conn.close()
			if results:
				return results
			else:
				return None;